#!/usr/local/bin/perl
#############################################################################
# Guest Book 98.1.0 Personal Version - Guestbook Viewer
#
# [Eng/Unix/Perl5]
#
# Written by Ray Chan, 1998/07/12
#
# Copyright 1997,1998 All Right Reserved.
#############################################################################
#
# Perl Reunion 98
# http://www.ray.org.hk/perl/
# perl@ray.org.hk
#
#############################################################################
#
# This script is free for personal use only.
# Please register the script if you find it useful, it is free anyway.
#
#############################################################################
#
# Disclaimer
#
# By using the script(s), you are agree and understand that the writers
# are not responsible for any damages caused under any conditions due to the
# malfunction or bugs from the script(s). Please use at your own risk.
#
#############################################################################
#
# guestbook.pl  - guest book viewer
#
#       This script is used to re-direct the guestbook database to the web.
#
#############################################################################
#
# Setup Section
#
#############################################################################
#                                                                            
# $cfgpath                                                                   
#       full and complete unix path to the configuration file                
                                                                             
$cfgpath='/usr1/home/jujubar/html/_GB/gbkcfg.txt';
                                                                             
#############################################################################
# End of Setup Section                                                       
#############################################################################

require 5;
require $cfgpath;

# read guestbook data from database
open (GBK, $guestsrc);
@GBKDATA=<GBK>;
close (GBK);

# count the total number of pages
$count=0;

foreach $rec (@GBKDATA){
	if ($rec =~ /<NEWBIE>/){
		$count++;
	}
}

$maxpage=int($count/$entryno);

if ($count/$entryno != int($count/$entryno)){
	$maxpage++;
}

if ($maxpage < 1){
	$maxpage=1;
}

# print html header
print "Content-type: text/html\n\n";

# read guestbook viewer header template
open (HEAD, $headersrc);
@DATA1=<HEAD>;
close (HEAD);

# printer header template
foreach $item (@DATA1){
	print "$item\n";
}


$temp=0;
$stop=0;
$more=0;
$flag=0;
$con=0;

# operation mode detection
if ($ARGV[0] eq ""){	# print the first page, default mode
	$min=0;
	$max=$entryno;
}

if ($ARGV[0] ne ""){	# print specific page
	$min=(($ARGV[0]-1)*$entryno)+1;
	$max=$ARGV[0]*$entryno;
}

# start printing guestbook data
foreach $item (@GBKDATA){
	chomp($item);
	if ($stop == 1){
		$more=1;
		break;
	}
	if ($temp >=$min -1 && $temp <=$max -1){
		print $item;
		$flag=1;
	}
 	if ($item eq "<NEWBIE>"){
		if ($temp>=$min -1 && $temp <=$max-1){
			print "<HR>";
		}
		$temp++;
		if ($temp >= $max){	
			$stop=1;
		}
	}
}

# print footer
if ($flag == 0){
	print "<B>Sorry, no entry yet.</B><HR>";
        if ($ontop1==0){
                print "Back to <A HREF=\"$backurl\">Home</A><P>";
        }
        if ($ontop1==1){
                print "Back to <A HREF=\"$backurl\" TARGET=\"_top\">Home</A><P>";
        }
        print "<CENTER>[Previous | Page 0 of 0 | Next]</CENTER>";
	print "</BODY></HTML>";
	$con=1;
}

if ($con==0){
	if ($ontop1==0){
		print "Back to <A HREF=\"$backurl\">Home</A><P>";
	}
	if ($ontop1==1){
		print "Back to <A HREF=\"$backurl\" TARGET=\"_top\">Home</A><P>";
	}

		if ($ARGV[0] eq ""){
			&bar(1,$maxpage);
		}else{
			&bar($ARGV[0],$maxpage);
		}
}

print "</CENTER></BODY></HTML>";


sub bar{
	local ($i)=0;
	$curr_page=$_[0];
	$max_page=$_[1];
	$first=int($curr_page/10)*10+1;
	$last=$first+9;
	if ($curr_page < $first){
		$first=$first-10;
		$last=$last-10;
	}
	if ($last > $max_page){
		$last=$max_page;
	}
	print "<P><CENTER>[";

	if ($first > 1){
		$prev_page=$first-1;
		$pi=$prev_page-9;
		print <<EOF;
		<A HREF="$booksrc?$prev_page" onmouseover="window.status='Go to previous section page $prev_page';return true">$pi - $prev_page</A> |
EOF
	}
	for($i=$first;$i<=$last;$i++){
		if ($i != $curr_page){
		print<<EOF;
		<A HREF="$booksrc?$i" onmouseover="window.status='Go to guestbook page $i';return true">$i</A>
EOF
		}else{
			print "&nbsp;$i&nbsp;";
		}
		if ($i<$last){
			print "|";
		}
	}

	if ($last < $max_page){
		$next_page=$last+1;
		$pi = $next_page+9;
		print <<EOF;
		|
		<A HREF="$booksrc?$next_page" onmouseover="window.status='Go to next section page $next_page';return true">$next_page - $pi</A>
EOF
	}
	print "]</CENTER>";
}
